(function(dependencies,module){"use strict";if(typeof define==="function"&&define.amd){return define(dependencies,module)}if(typeof exports==="object"){return module(exports,require("jio"),require("rsvp"))}window.index_storage={};module(window.index_storage,jIO,RSVP)})(["exports","jio","rsvp"],function(exports,jIO,RSVP){"use strict";function JSONIndex(spec){var that=this;spec=spec||{};that._id=spec._id;that._attachment=spec._attachment;that._indexing=spec.indexing||[];that._free=spec.free||[];that._location=spec.location||{};that._database=spec.database||[];that.modified=false;that.touch=function(){that.modified=true};that.put=function(meta){var k,needed_meta={},ok=false;if(typeof meta._id!=="string"||meta._id===""){throw new TypeError("Corrupted Metadata")}for(k in meta){if(meta.hasOwnProperty(k)){if(k[0]==="_"){if(k==="_id"){needed_meta[k]=meta[k]}}else if(that._indexing_object[k]){needed_meta[k]=meta[k];ok=true}}}if(ok){if(typeof that._location[meta._id]==="number"){that._database[that._location[meta._id]]=needed_meta}else if(that._free.length>0){k=that._free.shift();that._database[k]=needed_meta;that._location[meta._id]=k}else{that._database.push(needed_meta);that._location[meta._id]=that._database.length-1}that.modified=true;return true}if(typeof that._location[meta._id]==="number"){return that.remove(meta)}return false};that.remove=function(meta){if(typeof meta._id!=="string"){throw new TypeError("Corrupted Metadata")}if(typeof that._location[meta._id]!=="number"){return false}that._database[that._location[meta._id]]=null;that._free.push(that._location[meta._id]);delete that._location[meta._id];that.modified=true;return true};that.check=function(){var id,database_meta;if(typeof that._id!=="string"||that._id===""||typeof that._attachment!=="string"||that._attachment===""||!Array.isArray(that._free)||!Array.isArray(that._indexing)||typeof that._location!=="object"||Array.isArray(that._location)||!Array.isArray(that._database)||that._indexing.length===0){throw new TypeError("Corrupted Index")}for(id in that._location){if(that._location.hasOwnProperty(id)){database_meta=that._database[that._location[id]];if(typeof database_meta!=="object"||Object.getPrototypeOf(database_meta||[])!==Object.prototype||database_meta._id!==id){throw new TypeError("Corrupted Index")}}}};that.equals=function(json_index){function equalsDirection(a,b){var k;for(k in a._location){if(a._location.hasOwnProperty(k)){if(b._location[k]===undefined||JSON.stringify(b._database[b._location[k]])!==JSON.stringify(a._database[a._location[k]])){return false}}}return true}if(!equalsDirection(that,json_index)){return false}if(!equalsDirection(json_index,that)){return false}return true};that.checkDocument=function(doc){var i,key,db_doc;if(typeof that._location[doc._id]!=="number"){throw new TypeError("Different Index")}db_doc=that._database(that._location[doc._id])._id;if(db_doc!==doc._id){throw new TypeError("Different Index")}for(i=0;i<that._indexing.length;i+=1){key=that._indexing[i];if(doc[key]!==db_doc[key]){throw new TypeError("Different Index")}}};that.repair=function(){var i=0,meta;that._free=[];that._location={};if(!Array.isArray(that._database)){that._database=[]}while(i<that._database.length){meta=that._database[i];if(typeof meta==="object"&&Object.getPrototypeOf(meta||[])===Object.prototype&&typeof meta._id==="string"&&meta._id!==""&&!that._location[meta._id]){that._location[meta._id]=i;i+=1}else{that._database.splice(i,1)}}that.modified=true;return true};that.toJSON=function(){return{indexing:that._indexing,free:that._free,location:that._location,database:that._database}};that.check();that._indexing_object={};that._indexing.forEach(function(meta_key){that._indexing_object[meta_key]=true})}function similarityPercentage(list_a,list_b){var ai,bi,count=0;for(ai=0;ai<list_a.length;ai+=1){for(bi=0;bi<list_b.length;bi+=1){if(list_a[ai]===list_b[bi]){count+=1;break}}}return count/(list_a.length>list_b.length?list_a.length:list_b.length)}function IndexStorage(spec){var i;if(!Array.isArray(spec.indices)){throw new TypeError("IndexStorage 'indices' must be an array of "+"objects.")}this._indices=spec.indices;if(typeof spec.sub_storage!=="object"||Object.getPrototypeOf(spec.sub_storage||[])!==Object.prototype){throw new TypeError("IndexStorage 'sub_storage' must be a storage "+"description.")}for(i=0;i<this._indices.length;i+=1){if(typeof this._indices[i].id!=="string"||this._indices[i].id===""){throw new TypeError("IndexStorage "+"'indices[x].id' must be a non empty string")}if(!Array.isArray(this._indices[i].index)){throw new TypeError("IndexStorage "+"'indices[x].index' must be a string array")}}this._sub_storage=spec.sub_storage}IndexStorage.prototype.selectIndex=function(select_list){var i,tmp,selector={index:0,similarity:0};for(i=0;i<this._indices.length;i+=1){tmp=similarityPercentage(select_list,this._indices[i].index);if(tmp>selector.similarity){selector.index=i;selector.similarity=tmp}}return selector.index};IndexStorage.prototype.getIndexDatabase=function(command,index){index=this._indices[index];function makeNewIndex(){var json_index=new JSONIndex({_id:index.id,_attachment:index.attachment||"body",indexing:index.index});json_index.touch();return json_index}return command.storage(index.sub_storage||this._sub_storage).getAttachment({_id:index.id,_attachment:index.attachment||"body"}).then(function(response){return jIO.util.readBlobAsText(response.data)}).then(function(e){try{e=JSON.parse(e.target.result);e._id=index.id;e._attachment=index.attachment||"body"}catch(e1){return makeNewIndex()}return new JSONIndex(e)},function(err){if(err.status===404){return makeNewIndex()}throw err})};IndexStorage.prototype.getIndexDatabases=function(command){var i,promises=[];for(i=0;i<this._indices.length;i+=1){promises[promises.length]=this.getIndexDatabase(command,i)}return RSVP.all(promises)};IndexStorage.prototype.storeIndexDatabase=function(command,database,index){var that=this;if(!database.modified){return RSVP.resolve({result:"success"})}index=this._indices[index];function putAttachment(){return command.storage(index.sub_storage||that._sub_storage).putAttachment({_id:index.id,_attachment:index.attachment||"body",_data:JSON.stringify(database),_content_type:"application/json"})}function createDatabaseAndPutAttachmentIfPossible(err){var metadata;if(err.status===404){metadata={_id:index.id};if(typeof index.metadata==="object"&&index.metadata!==null&&!Array.isArray(index.metadata)){metadata=jIO.util.dictUpdate(metadata,index.metadata)}return command.storage(index.sub_storage||that._sub_storage).post(metadata).then(putAttachment,null,function(){throw null})}throw err}return putAttachment().then(null,createDatabaseAndPutAttachmentIfPossible)};IndexStorage.prototype.storeIndexDatabases=function(command,databases){var i,promises=[];for(i=0;i<this._indices.length;i+=1){if(databases[i]!==undefined){promises[promises.length]=this.storeIndexDatabase(command,databases[i],i)}}return RSVP.all(promises)};IndexStorage.prototype.genericCommand=function(method,command,metadata,option){var that=this,generic_response;function updateAndStoreIndexDatabases(responses){var i,database_list=responses[0];generic_response=responses[1];if(method==="get"){jIO.util.dictUpdate(metadata,generic_response.data)}metadata._id=generic_response.id;if(method==="remove"){for(i=0;i<database_list.length;i+=1){database_list[i].remove(metadata)}}else{for(i=0;i<database_list.length;i+=1){database_list[i].put(metadata)}}return that.storeIndexDatabases(command,database_list)}function allProgress(progress){if(progress.index===1){progress.value.percentage*=.7;command.notify(progress.value)}throw null}function success(){command.success(generic_response)}function storeProgress(progress){progress.percentage=.3*progress.percentage+70;command.notify(progress)}RSVP.all([this.getIndexDatabases(command),command.storage(this._sub_storage)[method](metadata,option)]).then(updateAndStoreIndexDatabases,null,allProgress).then(success,command.error,storeProgress)};IndexStorage.prototype.post=function(command,metadata,option){this.genericCommand("post",command,metadata,option)};IndexStorage.prototype.put=function(command,metadata,option){this.genericCommand("put",command,metadata,option)};IndexStorage.prototype.putAttachment=function(command,param,option){command.storage(this._sub_storage).putAttachment(param,option).then(command.success,command.error,command.notify)};IndexStorage.prototype.get=function(command,param,option){this.genericCommand("get",command,param,option)};IndexStorage.prototype.getAttachment=function(command,param,option){command.storage(this._sub_storage).getAttachment(param,option).then(command.success,command.error,command.notify)};IndexStorage.prototype.remove=function(command,param,option){this.genericCommand("remove",command,param,option)};IndexStorage.prototype.removeAttachment=function(command,param,option){command.storage(this._sub_storage).removeAttachment(param,option).then(command.success,command.error,command.notify)};IndexStorage.prototype.allDocs=function(command,param,option){var index=this.selectIndex(option.select_list||[]),delete_id,now;option.select_list=Array.isArray(option.select_list)?option.select_list:[];if(option.select_list.indexOf("_id")===-1){option.select_list.push("_id");delete_id=true}if(option.include_docs){now=Date.now();option.select_list.push("_"+now)}this.getIndexDatabase(command,index).then(function(db){var i,id;db=db._database;if(option.include_docs){for(i=0;i<db.length;i+=1){db[i]["_"+now]=db[i]}}jIO.QueryFactory.create(option.query||"").exec(db,option).then(function(){for(i=0;i<db.length;i+=1){id=db[i]._id;if(delete_id){delete db[i]._id}if(option.include_docs){db[i]={id:id,value:db[i],doc:db[i]["_"+now]};delete db[i].doc["_"+now];delete db[i].value["_"+now]}else{db[i]={id:id,value:db[i]}}}command.success(200,{data:{total_rows:db.length,rows:db}})})},function(err){if(err.status===404){return command.success(200,{data:{total_rows:0,rows:[]}})}command.error(err)})};jIO.addStorage("index",IndexStorage);exports.createDescription=function(){return}});